/*
 *Copyright (C) 1994-2000 The XFree86 Project, Inc. All Rights Reserved.
 *
 *Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 *"Software"), to deal in the Software without restriction, including
 *without limitation the rights to use, copy, modify, merge, publish,
 *distribute, sublicense, and/or sell copies of the Software, and to
 *permit persons to whom the Software is furnished to do so, subject to
 *the following conditions:
 *
 *The above copyright notice and this permission notice shall be
 *included in all copies or substantial portions of the Software.
 *
 *THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 *EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 *MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 *NONINFRINGEMENT. IN NO EVENT SHALL THE XFREE86 PROJECT BE LIABLE FOR
 *ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
 *CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 *WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *Except as contained in this notice, the name of the XFree86 Project
 *shall not be used in advertising or otherwise to promote the sale, use
 *or other dealings in this Software without prior written authorization
 *from the XFree86 Project.
 *
 * Authors:     Earle F. Philhower, III
 */
/* $$ */

#include <Xatom.h>
#include "propertyst.h"
#include "windowstr.h"
#include "winclass.h"

int GetClassHint(WindowPtr pWin, char **res_name, char **res_class)
{
  struct _Window *pwin;
  struct _Property *prop;
  pwin = (struct _Window*) pWin;
  int len_name, len_class;

  if (pwin->optional)
    prop = (struct _Property *)pwin->optional->userProps;
  else
    prop = NULL;
  
  *res_name = *res_class = NULL;
  while (prop) {
    if (prop->propertyName==XA_WM_CLASS
	&& prop->type==XA_STRING
	&& prop->format==8)
      {
	len_name = strlen((char *) prop->data);
	(*res_name) = malloc(len_name+1);
	strcpy((*res_name), prop->data);
	if (len_name==prop->size) len_name--;
	len_class = strlen(((char *)prop->data)+1+len_name);
	(*res_class) = malloc(len_class+1);
	strcpy((*res_class), ((char *)prop->data)+1+len_name);
	return 1;
      }
    else
      prop = prop->next;
  }
  
  return 0;
}
